library flutter_choose_date;

import 'package:flutter/material.dart';

import 'chooseDate/calendar_page_dialog.dart';
import 'chooseDate/calendar_page_viewModel.dart';

/// A Calculator.
class ChooseDateDialog {

  static void showChooseDateBottomDialog({
    BuildContext context,
    DayModel startTimeModel, //开始时间
    DayModel endTimeModel, //结束时间
    Function onCancel,
    Function(DayModel startTimeModel, DayModel endTimeModel) onConfirm
  }) {
    showBottomDialog(
        context: context,
        barrierDismissible: false,
        builder: (_) {
          return WillPopScope(
            onWillPop: () async {
              // 拦截到返回键，证明dialog被手动关闭
              return Future.value(true);
            },
            child: CalendarPageDialog(
                startTimeModel: startTimeModel,
                endTimeModel: endTimeModel,
                selectDateOnTap: onConfirm,
                onPressedCancel: onCancel),
          );
        });
  }


}

/// 底部弹窗
Future<T> showBottomDialog<T>({
  @required BuildContext context,
  bool barrierDismissible = true,
  WidgetBuilder builder,
}) {
  final ThemeData theme = Theme.of(context, shadowThemeOnly: true);
  return showModalBottomSheet(
    context: context,
    builder: (BuildContext context) {
      final Widget pageChild = Builder(builder: builder);
      return SafeArea(
        child: Builder(builder: (BuildContext context) {
          return theme != null
              ? Theme(data: theme, child: pageChild)
              : pageChild;
        }),
      );
    },
    isDismissible: barrierDismissible,
    backgroundColor: Color(0x00000000),
    isScrollControlled: true,
  );
}
